<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:06 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/executableDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/executabledoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/executableDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP function, method (member function) or constructor.
<a name="line22"></a> *
<a name="line23"></a> * @package PHPDoctor
<a name="line24"></a> * @abstract
<a name="line25"></a> */
<a name="line26"></a>class ExecutableDoc extends ProgramElementDoc
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** The parameters this function takes.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @var fieldDoc[]
<a name="line32"></a>	 */
<a name="line33"></a>	var $_parameters = array();
<a name="line34"></a>	
<a name="line35"></a>	/** The subfunctions this function has.
<a name="line36"></a>	 *
<a name="line37"></a>	 * @var methodDoc[]
<a name="line38"></a>	 */
<a name="line39"></a>	var $_functions = array();
<a name="line40"></a>
<a name="line41"></a>	/** The exceptions this function throws.
<a name="line42"></a>	 *
<a name="line43"></a>	 * @var classDoc[]
<a name="line44"></a>	 */
<a name="line45"></a>	var $_throws = array();
<a name="line46"></a>
<a name="line47"></a>	/** Add a subfunction to this function.
<a name="line48"></a>	 *
<a name="line49"></a>	 * @param MethodDoc function
<a name="line50"></a>	 */
<a name="line51"></a>	function addMethod(&$function)
<a name="line52"></a>    {
<a name="line53"></a>		$this->_functions[$function->name()] =& $function;
<a name="line54"></a>	}
<a name="line55"></a>
<a name="line56"></a>	/** Get argument information.
<a name="line57"></a>	 *
<a name="line58"></a>	 * @return FieldDoc[] An array of parameter, one element per argument in the
<a name="line59"></a>	 * order the arguments are present
<a name="line60"></a>	 */
<a name="line61"></a>	function &parameters()
<a name="line62"></a>    {
<a name="line63"></a>		return $this->_parameters;
<a name="line64"></a>	}
<a name="line65"></a>	
<a name="line66"></a>	/** Get subfunctions.
<a name="line67"></a>	 *
<a name="line68"></a>	 * @return MethodDoc[] An array of subfunctions.
<a name="line69"></a>	 */
<a name="line70"></a>	function &functions()
<a name="line71"></a>    {
<a name="line72"></a>		return $this->_functions;
<a name="line73"></a>	}
<a name="line74"></a>
<a name="line75"></a>	/** Return exceptions this function throws.
<a name="line76"></a>	 *
<a name="line77"></a>	 * @return ClassDoc[]
<a name="line78"></a>	 */
<a name="line79"></a>	function &thrownExceptions()
<a name="line80"></a>    {
<a name="line81"></a>		return $this->_throws;
<a name="line82"></a>	}
<a name="line83"></a>
<a name="line84"></a>	/** Return the param tags in this function.
<a name="line85"></a>	 *
<a name="line86"></a>	 * @return Tag[]
<a name="line87"></a>	 */
<a name="line88"></a>	function paramTags()
<a name="line89"></a>    {
<a name="line90"></a>		if (isset($this->_tags['@param'])) {
<a name="line91"></a>			if (is_array($this->_tags['@param'])) {
<a name="line92"></a>				return $this->_tags['@param'];
<a name="line93"></a>			} else {
<a name="line94"></a>				return array($this->_tags['@param']);
<a name="line95"></a>			}
<a name="line96"></a>		} else {
<a name="line97"></a>			return NULL;
<a name="line98"></a>		}
<a name="line99"></a>	}
<a name="line100"></a>
<a name="line101"></a>	/** Return the throws tags in this function.
<a name="line102"></a>	 *
<a name="line103"></a>	 * @return Type
<a name="line104"></a>	 */
<a name="line105"></a>	function throwsTags()
<a name="line106"></a>    {
<a name="line107"></a>		if (isset($this->_tags['@throws'])) {
<a name="line108"></a>			if (is_array($this->_tags['@throws'])) {
<a name="line109"></a>				return $this->_tags['@throws'];
<a name="line110"></a>			} else {
<a name="line111"></a>				return array($this->_tags['@throws']);
<a name="line112"></a>			}
<a name="line113"></a>		} else {
<a name="line114"></a>			return NULL;
<a name="line115"></a>		}
<a name="line116"></a>	}
<a name="line117"></a>
<a name="line118"></a>	/** Get the signature. It is the parameter list, type is qualified.
<a name="line119"></a>	 *
<a name="line120"></a>	 * <pre>for a function
<a name="line121"></a>	mymethod(foo x, int y)
<a name="line122"></a>it will return
<a name="line123"></a>	(bar.foo x, int y)</pre>
<a name="line124"></a>	 *
<a name="line125"></a>	 * Recognised types are turned into HTML anchor tags to the documentation
<a name="line126"></a>	 * page for the class defining them.
<a name="line127"></a>	 *
<a name="line128"></a>	 * @return str
<a name="line129"></a>	 */
<a name="line130"></a>	function signature()
<a name="line131"></a>    {
<a name="line132"></a>		$signature = '(';
<a name="line133"></a>		$myPackage =& $this->containingPackage();
<a name="line134"></a>		foreach($this->_parameters as $param) {
<a name="line135"></a>			$type = $param->type();
<a name="line136"></a>			$classDoc =& $type->asClassDoc();
<a name="line137"></a>			if ($classDoc) {
<a name="line138"></a>				$packageDoc =& $classDoc->containingPackage();
<a name="line139"></a>				$signature .= '<a href="'.str_repeat('../', $myPackage->depth() + 1).$classDoc->asPath().'">'.$classDoc->containingPackage().'.'.$classDoc->name().'</a> '.$param->name().$type->dimension().', ';
<a name="line140"></a>			} else {
<a name="line141"></a>				$signature .= $type->typeName().$type->dimension().', ';
<a name="line142"></a>			}
<a name="line143"></a>		}
<a name="line144"></a>		return substr($signature, 0, -2).')';
<a name="line145"></a>	}
<a name="line146"></a>
<a name="line147"></a>	/** Get flat signature. Return a string which is the flat signiture of this
<a name="line148"></a>	 * function. It is the parameter list, type is not qualified.
<a name="line149"></a>	 *
<a name="line150"></a>	 * <pre>for a function
<a name="line151"></a>	mymethod(foo x, int y)
<a name="line152"></a>it will return
<a name="line153"></a>	(foo x, int y)</pre>
<a name="line154"></a>	 *
<a name="line155"></a>	 * Recognised types are turned into HTML anchor tags to the documentation
<a name="line156"></a>	 * page for the class defining them.
<a name="line157"></a>	 *
<a name="line158"></a>	 * @return str
<a name="line159"></a>	 */
<a name="line160"></a>	function flatSignature()
<a name="line161"></a>    {
<a name="line162"></a>		$signature = '';
<a name="line163"></a>		$myPackage =& $this->containingPackage();
<a name="line164"></a>		foreach($this->_parameters as $param) {
<a name="line165"></a>			$type =& $param->type();
<a name="line166"></a>			$classDoc =& $type->asClassDoc();
<a name="line167"></a>			if ($classDoc) {
<a name="line168"></a>				$packageDoc =& $classDoc->containingPackage();
<a name="line169"></a>				$signature .= '<a href="'.str_repeat('../', $myPackage->depth() + 1).$classDoc->asPath().'">'.$classDoc->name().'</a> '.$param->name().', ';
<a name="line170"></a>			} else {
<a name="line171"></a>				$signature .= $type->typeName().' '.$param->name().', ';
<a name="line172"></a>			}
<a name="line173"></a>		}
<a name="line174"></a>		return '('.substr($signature, 0, -2).')';
<a name="line175"></a>	}
<a name="line176"></a>
<a name="line177"></a>}
<a name="line178"></a>
<a name="line179"></a>?>
<a name="line180"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/executabledoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>